# Running inference

*Estimated read time: 1 minute*

Once a model is loaded in PySDK (e.g., using `ModelSpec(...).load_model()`), you can run inference using three core methods:

* `predict`: run inference on a [single image](/axelera/basics/running-inference/images.md)
* `predict_batch`: run inference on a stream or iterator of images (ideal for video streams); for convenience, common video sources (e.g., files, webcams, and RTSP streams) are wrapped by [`degirum_tools.predict_stream`](/axelera/basics/running-inference/videos.md), which uses `predict_batch` under the hood and handles capture, looping, and cleanup for you
* `predict_dir`: run inference on [all images in a folder](/axelera/basics/running-inference/folders.md)


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.degirum.com/axelera/basics/running-inference.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
